import * as swagger from 'swagger2';

import swaggerRouter, {Router} from './router';
import ui from './ui';

const document = swagger.loadDocumentSync('./swagger.yml');
const router: Router = swaggerRouter(document);

router.get('/ping', async (context) => {
  context.status = 200;
  context.body = {
    serverTime: new Date().toISOString()
  };
});

router.put('/ping', async (context) => {
  context.status = 200;
  context.body = {
    pong: context.request.body
  };
});

router.app()
  .use(ui(document))
  .listen(3000);

// console.log('start on localhost:3000');
